<?php
  ############################################
  # Transfer © Alessandro Marinuzzi [Alecos] #
  # transfer.php • Version 1.7 • 18/06/2020  #
  # https://www.alecos.it • alecos@alecos.it #
  ############################################
  session_start();
  ob_start();
  @ini_set('default_charset', 'UTF-8');
  @set_time_limit(0);
  @ini_set('max_execution_time', 0);
  function check_protocol() {
    $isSecure = false;
    if (isset($_SERVER['HTTPS']) && strtolower($_SERVER['HTTPS']) == 'on') {
      $isSecure = true;
    } elseif (!empty($_SERVER['HTTP_X_FORWARDED_PROTO']) && strtolower($_SERVER['HTTP_X_FORWARDED_PROTO']) == 'https' || !empty($_SERVER['HTTP_X_FORWARDED_SSL']) && strtolower($_SERVER['HTTP_X_FORWARDED_SSL']) == 'on') {
      $isSecure = true;
    }
    return $isSecure;
  }
  $cookie_protocol = check_protocol() ? 'https' : 'http';
  $lang = isset($_SERVER['HTTP_ACCEPT_LANGUAGE']) ? substr($_SERVER['HTTP_ACCEPT_LANGUAGE'],0,2) : 'en';
  if ($lang == 'it') {
    $strg_00 = 'Transfer &bull; Calcola Il Trasferimento Di Un File';
    $strg_01 = 'Velocità';
    $strg_02 = 'Dimensioni';
    $strg_03 = 'Calcola';
    $strg_04 = 'Trasferiti';
    $strg_05 = 'Tempo Trascorso';
    $strg_06 = 'giorno';
    $strg_07 = 'ora';
    $strg_08 = 'minuto';
    $strg_09 = 'secondo';
    $strg_10 = 'giorni';
    $strg_11 = 'ore';
    $strg_12 = 'minuti';
    $strg_13 = 'secondi';
    $strg_14 = 'Byte';
    $strg_15 = 'Non abbandonare questa pagina! Sto calcolando...';
    $strg_16 = 'info';
    $strg_17 = 'Circa Transfer';
    $strg_18 = 'Calcolo eseguito in';
    $strg_19 = 'Reimposta';
  } else {
    $strg_00 = 'Transfer &bull; Calculates The Transfer Of A File';
    $strg_01 = 'Speed';
    $strg_02 = 'FileSize';
    $strg_03 = 'Calculate';
    $strg_04 = 'Transferred';
    $strg_05 = 'Elapsed Time';
    $strg_06 = 'day';
    $strg_07 = 'hour';
    $strg_08 = 'minute';
    $strg_09 = 'second';
    $strg_10 = 'days';
    $strg_11 = 'hours';
    $strg_12 = 'minutes';
    $strg_13 = 'seconds';
    $strg_14 = 'Bytes';
    $strg_15 = 'Do not leave this page! Calculating...';
    $strg_16 = 'info';
    $strg_17 = 'About Transfer';
    $strg_18 = 'Calculation performed in';
    $strg_19 = 'Reset';
  }
?>
<!DOCTYPE html>

<html lang="<?php echo $lang; ?>">

<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <meta name="author" content="Alecos [Alessandro Marinuzzi]">
  <meta name="generator" content="Notepad2">
  <meta name="distribution" content="global">
  <meta name="language" content="italian it">
  <meta name="language" content="english en">
  <meta name="rating" content="general">
  <meta name="revisit-after" content="6 days">
  <meta name="pragma" content="no-cache">
  <meta name="robots" content="noindex, nofollow">
  <title><?php echo $strg_00; ?></title>
  <style>
  <!--
  @import url('https://fonts.googleapis.com/css2?family=Oswald');
  @import url('https://fonts.googleapis.com/css2?family=Roboto+Condensed');
  html * {
    max-height: 1000000px;
  }
  html {
    display: table;
  }
  html, body {
    width: 100%;
    height: 100%;
    min-width: 640px;
  }
  body {
    font-family: 'Roboto Condensed', 'Helvetica Neue', Helvetica, Arial, sans-serif;
    font-size: 16px;
    font-style: normal;
    line-height: normal;
    font-weight: normal;
    font-variant: normal;
    background-color: #708090;
    color: #e6e6fa;
    display: table-cell;
    vertical-align: middle;
  }
  .link:link {
    color: #e6e6fa;
    text-decoration: none;
    background-color: #006699;
    border: 1px solid #000000;
    border-radius: 5px;
    padding-left: 3px;
    padding-right: 3px;
  }
  .link:visited {
    color: #e6e6fa;
    text-decoration: none;
    background-color: #006699;
    border: 1px solid #000000;
    border-radius: 5px;
    padding-left: 3px;
    padding-right: 3px;
  }
  .link:hover {
    color: #e6e6fa;
    text-decoration: none;
    background-color: #003399;
    border: 1px solid #000000;
    border-radius: 5px;
    padding-left: 3px;
    padding-right: 3px;
  }
  .mainbox {
    border-radius: 7px;
    padding: 10px;
    background-color: #6495ED;
    border: 3px solid #cccccc;
    width: 600px;
    height: auto;
    margin: 0 auto;
    margin-top: 50px;
    margin-bottom: 50px;
    display: block;
  }
  .box1 {
    border-radius: 7px;
    padding: 20px;
    background-color: #4169E1;
    border: 3px solid #cccccc;
    color: #e6e6fa;
    text-align: center;
    margin: 0 auto;
    display: block;
  }
  .box2 {
    border-radius: 7px;
    padding: 10px;
    background-color: #4169E1;
    border: 3px solid #cccccc;
    color: #e6e6fa;
    text-align: center;
    margin: 0 auto;
    display: block;
  }
  .box3 {
    border-radius: 7px;
    padding: 10px;
    background-color: #4169E1;
    border: 3px solid #cccccc;
    color: #e6e6fa;
    text-align: center;
    margin: 0 auto;
    display: block;
  }
  .box4 {
    border-radius: 7px;
    padding: 10px;
    background-color: #4169E1;
    border: 3px solid #cccccc;
    color: #e6e6fa;
    text-align: center;
    margin: 0 auto;
    display: block;
  }
  .warn {
    border-radius: 7px;
    padding: 10px;
    background-color: #4169E1;
    border: 3px solid #cccccc;
    color: #e6e6fa;
    text-align: center;
    margin: 0 auto;
  }
  .title {
    font-family: 'Roboto Condensed', 'Helvetica Neue', Helvetica, Arial, sans-serif;
    font-size: 26px;
    font-style: normal;
    line-height: normal;
    font-weight: normal;
    font-variant: normal;
    text-align: center;
    vertical-align: middle;
    color: #e6e6fa;
    margin: 0 auto;
    padding: 10px;
    display: block;
  }
  .calculate {
    font-family: 'Roboto Condensed', 'Helvetica Neue', Helvetica, Arial, sans-serif;
    font-size: 22px;
    font-style: normal;
    line-height: normal;
    font-weight: normal;
    font-variant: normal;
    border-radius: 5px;
    background-color: #708090;
    border: 3px solid #cccccc;
    color: #e6e6fa;
    cursor: pointer;
    box-shadow: inset -5px 5px 5px rgba(255, 255, 255, 0.15), inset 5px -5px 5px rgba(0, 0, 0, 0.15);
    text-align: center;
    vertical-align: middle;
    padding: 10px;
    margin: 0 auto;
    display: inline-block;
  }
  .calculate:hover {
    background-color: #DC143C;
  }
  .reset {
    font-family: 'Roboto Condensed', 'Helvetica Neue', Helvetica, Arial, sans-serif;
    font-size: 22px;
    font-style: normal;
    line-height: normal;
    font-weight: normal;
    font-variant: normal;
    border-radius: 5px;
    background-color: #708090;
    border: 3px solid #cccccc;
    color: #e6e6fa;
    cursor: pointer;
    box-shadow: inset -5px 5px 5px rgba(255, 255, 255, 0.15), inset 5px -5px 5px rgba(0, 0, 0, 0.15);
    text-align: center;
    vertical-align: middle;
    padding: 10px;
    margin: 0 auto;
    display: inline-block;
  }
  .reset:hover {
    background-color: #DC143C;
  }
  .input {
    font-family: 'Roboto Condensed', 'Helvetica Neue', Helvetica, Arial, sans-serif;
    font-size: 16px;
    font-style: normal;
    line-height: normal;
    font-weight: normal;
    font-variant: normal;
    border-radius: 5px;
    background-color: #708090;
    border: 3px solid #cccccc;
    color: #e6e6fa;
    width: 80px;
    text-align: center;
    padding: 3px;
    display: inline-block;
  }
  .label {
    font-family: 'Roboto Condensed', 'Helvetica Neue', Helvetica, Arial, sans-serif;
    font-size: 16px;
    font-style: normal;
    line-height: normal;
    font-weight: normal;
    font-variant: normal;
    border-radius: 5px;
    background-color: #708090;
    border: 3px solid #cccccc;
    color: #e6e6fa;
    width: 100px;
    text-align: center;
    padding: 3px;
    display: inline-block;
  }
  .info {
    font-family: 'Roboto Condensed', 'Helvetica Neue', Helvetica, Arial, sans-serif;
    font-size: 16px;
    font-style: normal;
    line-height: normal;
    font-weight: normal;
    font-variant: normal;
    border-radius: 5px;
    background-color: #708090;
    border: 2px solid #cccccc;
    color: #e6e6fa;
    cursor: pointer;
    box-shadow: inset -5px 5px 5px rgba(255, 255, 255, 0.15), inset 5px -5px 5px rgba(0, 0, 0, 0.15);
    text-decoration: none;
    text-align: center;
    vertical-align: middle;
    padding: 3px;
    display: inline-block;
  }
  .info:hover {
    background-color: #DC143C;
  }
  .radio {
    font-family: 'Roboto Condensed', 'Helvetica Neue', Helvetica, Arial, sans-serif;
    font-size: 16px;
    font-style: normal;
    line-height: normal;
    font-weight: normal;
    font-variant: normal;
    padding: 3px;
    display: inline-block;
  }
  .overlay {
    position: fixed;
    top: 0;
    bottom: 0;
    left: 0;
    right: 0;
    background: rgba(0, 0, 0, 0.7);
    transition: opacity 500ms;
    visibility: hidden;
    opacity: 0;
  }
  .overlay:target {
    visibility: visible;
    opacity: 1;
  }
  .popup {
    margin: 70px auto;
    padding: 30px;
    background: #fff;
    border-radius: 5px;
    width: 450px;
    position: relative;
    transition: all 5s ease-in-out;
  }
  .popup h2 {
    margin-top: 0;
    color: #000;
    font-family: Tahoma, Arial, sans-serif;
    font-size: 26px;
    font-style: normal;
    line-height: normal;
    font-weight: bold;
    font-variant: normal;
  }
  .popup .close {
    position: absolute;
    top: 25px;
    right: 30px;
    transition: all 200ms;
    text-decoration: none;
    color: #000;
    font-family: Tahoma, Arial, sans-serif;
    font-size: 30px;
    font-style: normal;
    line-height: normal;
    font-weight: bold;
    font-variant: normal;
  }
  .popup .close:hover {
    color: #000;
    font-family: Tahoma, Arial, sans-serif;
    font-size: 30px;
    font-style: normal;
    line-height: normal;
    font-weight: bold;
    font-variant: normal;
  }
  .popup .content {
    max-height: 30%;
    overflow: hidden;
    color: #000;
    font-family: 'Roboto Condensed', 'Helvetica Neue', Helvetica, Arial, sans-serif;
    font-size: 16px;
    font-style: normal;
    line-height: 30px;
    font-weight: normal;
    font-variant: normal;
  }
  .clear {
    clear: both;
    padding: 5px;
  }
  .cleardiv {
    clear: both;
    padding: 5px;
  }
  -->
  </style>
</head>

<body>

<div class="mainbox">
  <div class="title"><?php echo $strg_00; ?> <a class="info" href="#popup1"><?php echo $strg_16; ?></a><div id="popup1" class="overlay"><div class="popup"><h2><?php echo $strg_17; ?></h2><a class="close" href="#">&times;</a><div class="content">Transfer &copy; 2019-<?php echo date('Y'); ?> Alessandro Marinuzzi [Alecos]<br>Version: 1.7 &bull; Date: 18.06.2020 &bull; DonationWare License</div></div></div></div>
  <div class="box1">
    <form onReset="ClearForm(this);return false;" id="execute" name="execute" method="post" action="<?php echo htmlspecialchars($_SERVER['PHP_SELF'], ENT_QUOTES | ENT_HTML401, 'UTF-8'); ?>">
      <label class="label" for="speed_file"><?php echo $strg_01; ?></label>&nbsp;&nbsp;<input class="input" type="number" name="speed_file" id="speed_file" step="0.01" min="0" max="1000" value="<?php if (isset($_POST['speed_file']) && is_numeric($_POST['speed_file']) && $_POST['speed_file'] > 0) { echo htmlentities((float) $_POST['speed_file'], ENT_QUOTES | ENT_HTML401, 'UTF-8'); } else { echo 0; } ?>">&nbsp;&nbsp;<input class="radio" type="radio" name="specifier_s" value="KByte"<?php if (isset($_POST['specifier_s']) && $_POST['specifier_s'] == 'KByte') { echo ' checked'; } else { echo ''; } ?>>KByte&nbsp;<input class="radio" type="radio" name="specifier_s" value="MByte"<?php if (isset($_POST['specifier_s']) && $_POST['specifier_s'] == 'MByte') { echo ' checked'; } else { echo ''; } ?>>MByte&nbsp;<input class="radio" type="radio" name="specifier_s" value="GByte"<?php if (isset($_POST['specifier_s']) && $_POST['specifier_s'] == 'GByte') { echo ' checked'; } else { echo ''; } ?>>GByte&nbsp;<input class="radio" type="radio" name="specifier_s" value="TByte"<?php if (isset($_POST['specifier_s']) && $_POST['specifier_s'] == 'TByte') { echo ' checked'; } else { echo ''; } ?>>TByte<br><br>
      <label class="label" for="file_size"><?php echo $strg_02; ?></label>&nbsp;&nbsp;<input class="input" type="number" name="file_size" id="file_size" step="0.01" min="0" max="1000" value="<?php if (isset($_POST['file_size']) && is_numeric($_POST['file_size']) && $_POST['file_size'] > 0) { echo htmlentities((float) $_POST['file_size'], ENT_QUOTES | ENT_HTML401, 'UTF-8'); } else { echo 0; } ?>">&nbsp;&nbsp;<input class="radio" type="radio" name="specifier_f" value="KByte"<?php if (isset($_POST['specifier_f']) && $_POST['specifier_f'] == 'KByte') { echo ' checked'; } else { echo ''; } ?>>KByte&nbsp;<input class="radio" type="radio" name="specifier_f" value="MByte"<?php if (isset($_POST['specifier_f']) && $_POST['specifier_f'] == 'MByte') { echo ' checked'; } else { echo ''; } ?>>MByte&nbsp;<input class="radio" type="radio" name="specifier_f" value="GByte"<?php if (isset($_POST['specifier_f']) && $_POST['specifier_f'] == 'GByte') { echo ' checked'; } else { echo ''; } ?>>GByte&nbsp;<input class="radio" type="radio" name="specifier_f" value="TByte"<?php if (isset($_POST['specifier_f']) && $_POST['specifier_f'] == 'TByte') { echo ' checked'; } else { echo ''; } ?>>TByte<br><br>
      <input class="calculate" name="calculate" type="submit" onclick="SubmitForm()" value="<?php echo $strg_03; ?>">&nbsp;&nbsp;<input class="reset" name="reset" type="reset" value="<?php echo $strg_19; ?>">
    </form>
  </div>
  <div class="cleardiv"></div>
<?php
  $speed_file = 0;
  $file_size = 0;
  $temp_speed_file = 0;
  $temp_file_size = 0;
  $human_speed_file = '';
  $human_file_size = '';
  $counter_bytes = 0;
  $counter_seconds = 0;
  $seconds_real = 0;
  $rest_seconds = 0;
  $minutes_real = 0;
  $rest_minutes = 0;
  $hours_real = 0;
  $rest_hours = 0;
  $days_real = 0;
  $ini_time = 0;
  $end_time = 0;
  $dif_time = 0;
  $mytime = '00:00:00';
  $speed_file = (isset($_POST['speed_file']) && is_numeric($_POST['speed_file']) && $_POST['speed_file'] > 0) ? htmlentities((float) $_POST['speed_file'], ENT_QUOTES | ENT_HTML401, 'UTF-8') : 0;
  $specifier_s = isset($_POST['specifier_s']) ? htmlentities($_POST['specifier_s'], ENT_QUOTES | ENT_HTML401, 'UTF-8') : 'KByte';
  $file_size = (isset($_POST['file_size']) && is_numeric($_POST['file_size']) && $_POST['file_size'] > 0) ? htmlentities((float) $_POST['file_size'], ENT_QUOTES | ENT_HTML401, 'UTF-8') : 0;
  $specifier_f = isset($_POST['specifier_f']) ? htmlentities($_POST['specifier_f'], ENT_QUOTES | ENT_HTML401, 'UTF-8') : 'KByte';
  switch ($specifier_s) {
    case 'KByte':
      $temp_speed_file = $speed_file * 1024;
      $human_speed_file = 'KB/s';
    break;
    case 'MByte':
      $temp_speed_file = $speed_file * 1024 * 1024;
      $human_speed_file = 'MB/s';
    break;
    case 'GByte':
      $temp_speed_file = $speed_file * 1024 * 1024 * 1024;
      $human_speed_file = 'GB/s';
    break;
    case 'TByte':
      $temp_speed_file = $speed_file * 1024 * 1024 * 1024 * 1024;
      $human_speed_file = 'TB/s';
    break;
    default:
  }
  switch ($specifier_f) {
    case 'KByte':
      $temp_file_size = $file_size * 1024;
      $human_file_size = 'KB';
    break;
    case 'MByte':
      $temp_file_size = $file_size * 1024 * 1024;
      $human_file_size = 'MB';
    break;
    case 'GByte':
      $temp_file_size = $file_size * 1024 * 1024 * 1024;
      $human_file_size = 'GB';
    break;
    case 'TByte':
      $temp_file_size = $file_size * 1024 * 1024 * 1024 * 1024;
      $human_file_size = 'TB';
    break;
    default:
  }
  if (($speed_file > 0) && ($speed_file <= 1000) && ($file_size > 0) && ($file_size <= 1000)) {
    $ini_time = microtime(true);
    if ($cookie_protocol == 'http') {
      setcookie('ini_time', $ini_time, ['expires' => 0, 'path' => '', 'domain' => '', 'secure' => false, 'httponly' => true]);
    } else {
      setcookie('ini_time', $ini_time, ['expires' => 0, 'path' => '', 'domain' => '', 'secure' => true, 'httponly' => true, 'samesite' => 'Lax']);
    }
    $_COOKIE['ini_time'] = htmlentities($ini_time, ENT_QUOTES | ENT_HTML401, 'UTF-8');
    while ($counter_bytes < $temp_file_size) {
      $counter_bytes += $temp_speed_file;
      ++$counter_seconds;
      $seconds_real = $counter_seconds;
      if ($seconds_real >= 60) {
        $minutes_real = ($seconds_real / 60);
        $rest_seconds = ($seconds_real % 60);
      }
      if ($minutes_real >= 60) {
        $hours_real = ($seconds_real / 3600);
        $rest_minutes = ($seconds_real % 3600);
        if ($rest_minutes >= 60) {
          $rest_minutes /= 60;
        }
      }
      if ($hours_real >= 24) {
        $days_real = ($seconds_real / 86400);
        $rest_hours = ($seconds_real % 86400);
        if ($rest_hours >= 24) {
          $rest_hours /= 3600;
        }
      }
    }
  }
  if ($speed_file <= 0) {
    $file_size = 0;
    $temp_file_size = 0;
  }
  function TakeCalcTime($seconds) {
    global $mytime;
    $hours = floor($seconds / 3600);
    $seconds -= $hours * 3600;
    $minutes = floor($seconds / 60);
    $seconds -= $minutes * 60;
    $mytime = sprintf('%02d', $hours) . ':' . sprintf('%02d', $minutes) . ':' . sprintf('%02d', $seconds);
  }
  if ((isset($_COOKIE['ini_time'])) && (!empty($_COOKIE['ini_time']))) {
    $ins_time = htmlentities($_COOKIE['ini_time'], ENT_QUOTES | ENT_HTML401, 'UTF-8');
    $end_time = microtime(true);
    $dif_time = $end_time - $ins_time;
  }
  if ((isset($ins_time)) && (!empty($ins_time))) {
    if ($dif_time > 0) {
      TakeCalcTime($dif_time);
    }
    if ($cookie_protocol == 'http') {
      setcookie('ini_time', '', ['expires' => 0, 'path' => '', 'domain' => '', 'secure' => false, 'httponly' => true]);
    } else {
      setcookie('ini_time', '', ['expires' => 0, 'path' => '', 'domain' => '', 'secure' => true, 'httponly' => true, 'samesite' => 'Lax']);
    }
    unset($_COOKIE['ini_time']);
    unset($ini_time);
    unset($ins_time);
  }
  ob_end_flush();
  session_destroy();
?>
  <div style="display: none" id="warn" class="warn"><?php echo $strg_15; ?></div>
  <div style="display: none" id="clear" class="clear"></div>
  <div class="box2"><?php echo "&#9873; $strg_01: " . (float) $speed_file . " $human_speed_file &#9873; $strg_04: " . (float) $file_size . " $human_file_size (" . (int) $temp_file_size . " $strg_14)"; ?></div>
  <div class="cleardiv"></div>
  <div class="box3"><?php
  echo "$strg_05:";
  if (($days_real == 0) && ($hours_real == 0) && ($minutes_real == 0) && ($seconds_real == 0)) {
    echo " &#9755; 0";
  }
  if ($days_real > 0) {
    echo " &#9755; " . (int) $days_real . ((int) $days_real == 1 ? " $strg_06" : " $strg_10");
    echo " &#9755; " . (int) $rest_hours . ((int) $rest_hours == 1 ? " $strg_07" : " $strg_11");
    echo " &#9755; " . (int) $rest_minutes . ((int) $rest_minutes == 1 ? " $strg_08" : " $strg_12");
    echo " &#9755; " . (int) $rest_seconds . ((int) $rest_seconds == 1 ? " $strg_09" : " $strg_13");
  }
  if (($hours_real > 0) && ($hours_real < 24)) {
    echo " &#9755; " . (int) $hours_real . ((int) $hours_real == 1 ? " $strg_07" : " $strg_11");
    echo " &#9755; " . (int) $rest_minutes . ((int) $rest_minutes == 1 ? " $strg_08" : " $strg_12");
    echo " &#9755; " . (int) $rest_seconds . ((int) $rest_seconds == 1 ? " $strg_09" : " $strg_13");
  }
  if (($minutes_real > 0) && ($minutes_real < 60)) {
    echo " &#9755; " . (int) $minutes_real . ((int) $minutes_real == 1 ? " $strg_08" : " $strg_12");
    echo " &#9755; " . (int) $rest_seconds . ((int) $rest_seconds == 1 ? " $strg_09" : " $strg_13");
  }
  if (($seconds_real > 0) && ($seconds_real < 60)) {
    echo " &#9755; " . (int) $seconds_real . ((int) $seconds_real == 1 ? " $strg_09" : " $strg_13");
  }
?></div>
  <div class="cleardiv"></div>
  <div class="box4"><?php echo "&#9972; $strg_18: " . ((($speed_file > 0) && ($speed_file <= 1000) && ($file_size > 0) && ($file_size <= 1000)) ? $mytime : '00:00:00'); ?></div>
  <div class="cleardiv"></div>
</div>

<script>
function ClearForm(form) {
  form.elements['speed_file'].value = "";
  form.elements['file_size'].value = "";
  var specifier_s = document.getElementsByName("specifier_s");
  var specifier_f = document.getElementsByName("specifier_f");
  for (var s = 0; s < specifier_s.length; s++) {
    specifier_s[s].checked = false;
  }
  for (var f = 0; f < specifier_f.length; f++) {
    specifier_f[f].checked = false;
  }
}
function SubmitForm() {
  StartInfo();
  execute = document.getElementById("execute");
  execute.submit();
}
function StartInfo() {
  speed_file = document.getElementById("speed_file").value;
  file_size = document.getElementById("file_size").value;
  if ((speed_file > 0) && (speed_file <= 1000) && (file_size > 0) && (file_size <= 1000)) {
    document.getElementById("warn").style.display = "block";
    document.getElementById("clear").style.display = "block";
    return true;
  } else {
    document.getElementById("warn").style.display = "none";
    document.getElementById("clear").style.display = "none";
    return true;
  }
}
</script>

</body>

</html>